/*
*****************************************************************************
*
*   File        : tfo_decision.h We consider version handling no longer;
*   NOTE        : it is not expected that this SW will ever change,
*                 therefore all version handling is removed.
*   Version     : C.0.0, 02. December 2014, Karl Hellwig, Ericsson
*   Version     : B.0.0, 18. September 2012, Paolo Usai, Karl Hellwig
*   Version     : A.0.0, 13. April 2011, Karl Hellwig
*   Version     : 9.0.0, 11. December 2009, Paolo Usai
*   Version     : 8.1.0, 27. March 2009, Karl Hellwig
*   Version     : 7.0.0, 14. June 2007, Paolo Usai
*   Version     : 6.4.0, 05. June 2007, Karl Hellwig
*   Version     : 6.3.0, 02. October 2006, Karl Hellwig
*   Version     : 6.2.0, 30. August 2005, Karl Hellwig
*   Version     : 2.0.0, 15. November 2000, Jochen Junkawitsch
*   Description	: header file for TFO decision algorithm
*
******************************************************************************
*/

#ifndef TFO_DECISION_H_INCLUDED
#define TFO_DECISION_H_INCLUDED

#include "oacs.h"		/* KHe: consider version here no longer */

typedef struct
{
  CodecType lType;
  CodecSet	lacs;
  CodecSet	lscs;
  int		lmacs;
  int		lOM;

  CodecType dType;
  CodecSet	dacs;
  CodecSet	dscs;
  int		dmacs;
  int		dOM;

  CodecSet	oacs;
  CodecSet	cscs;
  CodecSet	cacs;
  CodecSet	iacs;
  int		cmacs;
  
} Data;


int      helptext (void);
int      tfo_decision_main           (Data* data);
int      tfo_decision_AMR            (Data* data);

int      immediate_TFO               (Data* data);
int      codec_mismatch_resolution   (Data* data);
int      change_to_OACS              (Data* data);
int      codec_mode_optimization     (Data* data);
int      FR_HR_optimization          (Data* data);

int      determine_OACS              (Data* data);
int      determine_IACS              (Data* data);
int      acceptable                  (Data* data, CodecSet cs);
int      FR_HR_matching              (Data* data);
int      contiguous_subset           (CodecSet a, CodecSet b);
int      calc_OACS_case1             (Data* data);
int      calc_OACS_case2             (Data* data);
CodecSet contiguous_subset_selection (CodecSet cs, int lOM, int dOM, CodecSet lacs, CodecSet dacs, int cmacs);
char*    modeName                    (CodecMode m);
char*    WBmodeName                  (CodecMode m);
char*    codecName                   (CodecType t);

#endif

